--同调器系统
checkRequire("Lua_GodTreePanel"); --同调器
checkRequire("Lua_GodStatuePanel");--英雄之力
Lua_LifeTreeWindow = class("Lua_LifeTreeWindow", Lua_Window);
function Lua_LifeTreeWindow:ctor()
	self:superCall("ctor");
	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
    self.isFullSizeWin = true;
    self.showBackBtn = true;
    self.isSingleShowWin = true;
	self.windowName = "Lua_LifeTreeWindow";

   	self.modelUrl = "/effects/scsEffects/tongdiaoqi_renwu";
   	self:addPreLoadRes(self.modelUrl, Lua_LoadFileType.UNITY3D);
end

function Lua_LifeTreeWindow:buildShowItem()
	self:superCall("buildShowItem");
	
    self.showBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_widget_005", 0, 60.5, 720, 121);
    self.showBg.anchor = Lua_WindowUtil.getAnchor(7);
    self.showBg.siblingIndex = 2;

    self.backBtn:setLocation(58,56,0);
	self.backBtn.siblingIndex = 1;
	
	self.roleInfoPanel = Lua_RoleInfoPanel.new(self.content,Lua_ResourcesDefine.STAR_LUCK);
    self.roleInfoPanel:setRectAnchor(1);

	self.panelObjTab = {};
	self.tabInfo = Array();
	self.tabInfo:add({ textAtlas = "life_tree_altas", textNormalSprite = "xui_tdq_button_2_n", textSelectedSprite = "xui_tdq_button_2_p" ,panel = Lua_GodTreePanel, redPointId = Lua_RedPointList.Main_LifeTree_GodTab});
	self.tabInfo:add({ textAtlas = "life_tree_altas", textNormalSprite = "xui_tdq_button_1_n", textSelectedSprite = "xui_tdq_button_1_p",panel = Lua_GodStatuePanel,redPointId = Lua_RedPointList.Main_LifeTree_StatueTab});

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setRectAnchor(7);
	self.btnList:setLocation(239, 53.5, 0);
	self.btnList.pivot = -1;
	self.btnList:setButtonStyle("common_altas_1", "ui_common_button_001_b", "ui_common_button_001_b", 118, 108, 0.01, 1);
	self.btnList:setButtonLine("common_altas_1", "ui_common_line_011", 2, 108, 0, 0, 1);
	self.btnList:setButtonItem(120, 108);
	self.btnList:setRedPoint(42, 41);
	self.btnList:setClickCallBack(self, self.onTabBtnClick);
	self.btnList:setData(self.tabInfo);

	self:showMondelScene(Lua_LifeTreeUtil.sceneId);
end

function Lua_LifeTreeWindow:showWin(param)
	local idx = 1;
	if type(param) == "number" then
		idx = param;
	else
		idx = param.main_id;
	end
	self.btnList:setSelected(idx);
end

function Lua_LifeTreeWindow:onBackBtnClick()
	DataCenter.funcPathUtil:gotoFunction(1098, true);
end

function Lua_LifeTreeWindow:onTabBtnClick(val)
	if self.selectTabIndex == val then
		return;
	end
	-- 隐藏旧的
	self.panel = self.panelObjTab[self.selectTabIndex];
	if self.panel ~= nil then
		self.panel:setEnable(false);
		if self.panel.setModelEnable ~= nil then
			self.panel:setModelEnable(false);
		end
	end
	

	self.selectTabIndex = val;
	self.panel = self.panelObjTab[val];
	if self.panelObjTab[val] == nil then
		local showPanel = self.tabInfo[val].panel;
		self.panel = showPanel.new(self.content);
		self.panel:setRectAnchor(9);
		self.panel:setSiblingIndex(0)
		self.panelObjTab[val] = self.panel;
		self.roleInfoPanel:setSiblingIndex(self.panel.siblingIndex + 1);
	else
		self.panel:setEnable(true);
	end
	if self.panel.showTreeScene ~= nil then
		self.panel:showTreeScene(self.modelScenePanel);
	end
	if self.panel.onScreenResize ~= nil then
		self.panel:onScreenResize(self.adaptHeight);
	end
	if self.panel.updateTween ~= nil then
		self.panel:updateTween();
	end
end

-- 模型场景展示
function Lua_LifeTreeWindow:showMondelScene(sceneId)
	self.sceneId = sceneId;
    if self.modelScenePanel == nil then--场景模型
        self.modelScenePanel = Lua_MultiModelScenePanel.new()
        self.modelScenePanel:addSceneCallBack(self, self.showSceneCallBack)
    end
    self.modelScenePanel:showModelScene(sceneId);
    self:showEffectScene(sceneId);
end

function Lua_LifeTreeWindow:showSceneCallBack(sceneId)
    self.modelScenePanel:setModelEnable(self.selectTabIndex == 1 and DataCenter.lifeTreeData.break_state ~= 2);
end

-- 场景特效
function Lua_LifeTreeWindow:showEffectScene(sceneId)
    if self.showModelEff == nil then
		local url = UrlManager.fixFileSuffix(self.modelUrl);
	    self.showModelEff = ModelEffComponent(sceneId, 0);
	    self.showModelEff:setLocation(0,0.25,0);
	    self.showModelEff:setFullUrl(url, "tongdiaoqi_renwu", "tongdiaoqi_renwu", nil);
	else
		self.showModelEff:setSceneInfo(sceneId, 0);
	end
end

function Lua_LifeTreeWindow:resetActive(bActive)
    self:superCall("resetActive", bActive);
    if bActive then -- 显示
	    if self.sceneId ~= nil then
        	self:showMondelScene(self.sceneId);
        end
    else
        if self.modelScenePanel ~= nil then
            self.modelScenePanel:dispose();
            self.modelScenePanel = nil;
        end

        if self.showModelEff ~= nil then
        	self.showModelEff:dispose();
        	self.showModelEff = nil;
        end
    end
end

function Lua_LifeTreeWindow:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end

	if self.panelObjTab ~= nil then
		for idx, panelObj in pairs(self.panelObjTab) do
            panelObj:dispose();
            self.panelObjTab[idx] = nil;
        end
		self.panelObjTab = nil;
	end

	if self.tabInfo ~= nil then
		self.tabInfo:dispose();
		self.tabInfo:clear();
		self.tabInfo = nil;
	end
	if self.roleInfoPanel ~= nil then
		self.roleInfoPanel:dispose();
		self.roleInfoPanel = nil;
	end

	if self.showModelEff ~= nil then
        self.showModelEff:dispose();
        self.showModelEff = nil;
    end

	self:superCall("dispose");
end