--英雄之力
Lua_GodStatuePanel = class("Lua_GodStatuePanel", Lua_DisplayObject);
function Lua_GodStatuePanel:ctor(p)
    self:superCall("ctor", p,"GodStatuePanel_skin");
end

function Lua_GodStatuePanel:buildShowItem()
    self:superCall("buildShowItem");
    local adaptHeight = self.adaptHeight;
    if adaptHeight <= 0 then
        adaptHeight = -adaptHeight;
        self.bg:SetDimensions(720, 698);
    else
        self.bg:SetDimensions(720, 698 + adaptHeight);
    end
    
    self.bg:setLocation(0, 90 + adaptHeight/2);
    LuaUtil.setObjPos(self.show_obj,0, 0 + adaptHeight/2, 0);

    self.stoneBtn:setEnable(false);--按钮屏蔽
    self.help:addClickFuntion(self, self.onHelpBtnClick);
    self.stoneBtn:addClickFuntion(self, self.onStoneBtnClick);
    self.upgradeBtn:addClickFuntion(self, self.onUpgradeBtnClick);
    
    self:addLuaEvent("MONEY_UPDATE", self, self.showCost);--材料更新
    self:addLuaEvent("GOD_STATUE_INFO", self, self.updateGodStatueInfo);
    self:addLuaEvent("UPDATE_STATUE_TAB_REDDOT", self, self.updateGodStatueRed);
    
    if DataCenter.lifeTreeData.bInitStoneInfo == true then
        self:updateGodStatueInfo(true);
    else
        Lua_ProxyManager.getProxy("Lua_LifeTreeProxy"):sStatue();
    end
end

--更新英雄之力
function Lua_GodStatuePanel:updateGodStatueInfo(isDelay)
    local str = DataCenter.lifeTreeData.statue_cur_force;
    if DataCenter.lifeTreeData.statue_next_force ~= 0 then
        str = str.."<color=#479154>(+"..DataCenter.lifeTreeData.statue_next_force..")</color>";
    end
    self.show_foce.text = LanUtil.formateStr(126960, tostring(str));
    local str = "Lv."..Lua_ColorDefine.getColorStr("fcc513",DataCenter.lifeTreeData.statue_level).."/";
    self.level.text = str..DataCenter.lifeTreeUtil.statue_limit;
    self:showCost();
    self:updateProp();
    self:updateAddProp();
    self:updateGodStatueRed();
    if DataCenter.lifeTreeData.isShowOpenWin == true then
        if isDelay then
            Lua_CommonUtil.delayCall(0.5, self, self.openWin);
        else
            self:openWin();
        end
    end
end

--红点更新
function Lua_GodStatuePanel:updateGodStatueRed()
    --self:showStoneRedDot();--红点隐藏，数据类也进行了隐藏。需要展示记得数据类也处理下。
    self:showUpgradeRedDot();
end

-- 材料消耗
function Lua_GodStatuePanel:showCost()
    self.data = DataCenter.lifeTreeUtil:getStarStatueInfo(DataCenter.lifeTreeData.statue_level);
    if self.data.next_id == 0 then--已满级
        self.cont_obj:SetActive(false);
    else
        self.cont_obj:SetActive(true);
        self.item_id = self.data.cost[1][1];
        self.have_num = DataCenter.packData:getItemCountById(self.item_id);
        self.need_num = self.data.cost[1][2];
        local color = "FCF7F0";
        if self.have_num < self.need_num then
            color = "ed4c30";
        end
        local tvo = Lua_ToolVo.new(self.item_id);
        if tvo ~= nil then
            self.iocn:setAltas(tvo.atlas, tvo.sprite);
        end
        self.num.text = "<color=#"..color..">"..numberTrans(self.have_num).."</color>/"..numberTrans(self.need_num);
    end
end

--打开能量收取
function Lua_GodStatuePanel:openWin()
    Lua_CommonUtil.removeTimer(self, self.openWin);
    Lua_WindowUtil.openWin("Lua_GodStatueEnergyWindow", Lua_WinParam.ACTION_OPEN);
end

-- 更新属性
function Lua_GodStatuePanel:updateProp()
    local arr = DataCenter.lifeTreeUtil:getShowProp(DataCenter.lifeTreeData.statue_prop_list, DataCenter.lifeTreeData.statue_next_prop_list);
    if self.attributeArr == nil then
        self.attributeArr = Array();
    end
    local len = self.attributeArr:getSize();
    for i = 1, len do
        self.attributeArr[i]:setEnable(false);
    end
    for i = 1, arr:getSize() do
        local item = nil;
        if self.attributeArr[i] ~= nil then
            item = self.attributeArr[i];
        else
            item = Lua_GodStatuePorpItem.new(self.show_obj);
            self.attributeArr:add(item);
        end
        item:setData(arr[i]);
        item:setEnable(true);

        local x = 0;
        if i%2 == 0 then
            x = 31;
            i =i/2;
        else
            x = -294;
            i =(i+1)/2;
        end
        item:setLocation(x, -284 - (i-1)*62, 0);
    end
end

-- 更新加成属性
function Lua_GodStatuePanel:updateAddProp()
    local arr = DataCenter.lifeTreeUtil:getShowAddProp(DataCenter.lifeTreeData.statue_level);
    if self.addProArr == nil then
        self.addProArr = Array();
    end
    local len = self.addProArr:getSize();
    for i = 1, len do
        self.addProArr[i]:setEnable(false);
    end
    for i = 1, arr:getSize() do
        local item = nil;
        if self.addProArr[i] ~= nil then
            item = self.addProArr[i];
        else
            item = Lua_GodStatuePorpItem.new(self.show_obj);
            self.addProArr:add(item);
        end
        item:setData(arr[i]);
        item:setEnable(true);
        item:setLocation(-294 + (i-1)*325, -408, 0);
    end
end

--宝石红点
function Lua_GodStatuePanel:showStoneRedDot()
    local val = DataCenter.lifeTreeData.stoneRedDot;
    if val == true then
        if self.redDotIcon2 == nil then
            self.redDotIcon2 = Lua_RedPointIcon.new(self.show_obj);
            self.redDotIcon2:setLocation(312, -20, 0);
            self.redDotIcon2:createRedPointImg(nil);
        end
        self.redDotIcon2:updateRedPointShow(true);
    else
        if self.redDotIcon2 ~= nil then
            self.redDotIcon2:updateRedPointShow(false);
        end
    end
end

--升级红点
function Lua_GodStatuePanel:showUpgradeRedDot()
    local val = DataCenter.lifeTreeData.statueUpgradeRedDot;
    if val == true then
        if self.redDotIcon1 == nil then
            self.redDotIcon1 = Lua_RedPointIcon.new(self.cont_obj);
            self.redDotIcon1:setLocation(95, -538, 0);
            self.redDotIcon1:createRedPointImg(nil);
        end
        self.redDotIcon1:updateRedPointShow(true);
    else
        if self.redDotIcon1 ~= nil then
            self.redDotIcon1:updateRedPointShow(false);
        end
    end
end

-- 英雄之力特效
function Lua_GodStatuePanel:showEffect(bool)
    
end

--英雄之力升级
function Lua_GodStatuePanel:onUpgradeBtnClick()
    if self.data == nil then
        return;
    end
    if self.data.next_id == 0 then--满级
        OperateAlert.showLangValue(126961);
        return 
    end

    if self.have_num < self.need_num then
        DataCenter.packUtil:openPathWindow(self.item_id);
        return
    end
    Lua_ProxyManager.getProxy("Lua_LifeTreeProxy"):sStatueUpgrade();
end

function Lua_GodStatuePanel:onHelpBtnClick()
    local tipsData = { des = LanUtil.getValue(126951), posX = 173, posY = -273 };
    Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

-- 宝石
function Lua_GodStatuePanel:onStoneBtnClick(bool)
    Lua_WindowUtil.openWin("Lua_GodStatueStoneWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_GodStatuePanel:onScreenResize(adaptHeight)
    if self.adaptHeight == adaptHeight then
        return
    end
    self:superCall("onScreenResize", adaptHeight);

    if adaptHeight <= 0 then
        adaptHeight = -adaptHeight;
        self.bg:SetDimensions(720, 698);
    else
        self.bg:SetDimensions(720, 698 + adaptHeight);
    end
    
    self.bg:setLocation(0, 90 + adaptHeight/2);
    LuaUtil.setObjPos(self.show_obj, 0, 0 + adaptHeight/2, 0);
end

function Lua_GodStatuePanel:dispose()
    if self.attributeArr ~= nil then
        self.attributeArr:dispose();
        self.attributeArr:clear();
        self.attributeArr = nil;
    end
    if self.addProArr ~= nil then
        self.addProArr:dispose();
        self.addProArr:clear();
        self.addProArr = nil;
    end
    if self.redDotIcon1 ~= nil then
        self.redDotIcon1:dispose();
        self.redDotIcon1 = nil;
    end
    if self.redDotIcon2 ~= nil then
        self.redDotIcon2:dispose();
        self.redDotIcon2 = nil;
    end

    if self.modelScenePanel ~= nil then
        self.modelScenePanel:dispose();
        self.modelScenePanel = nil;
    end
    self.data = nil;
    Lua_CommonUtil.removeTimer(self, self.openWin);
    self:superCall("dispose");
end














--属性展示
Lua_GodStatuePorpItem = class("Lua_GodStatuePorpItem", Lua_DisplayObject);
function Lua_GodStatuePorpItem:ctor(p)
    self:superCall("ctor", p,"GodStatuePropItem_skin");
end

function Lua_GodStatuePorpItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_GodStatuePorpItem:setData(data)
    local str = "";
    if data.nextValue > 0 then
        str = "<color=#479154>(+"..data.showNextValue..")</color>";
    end
    self.des.text = data.show_name.."："..data.showValue..str;
    self.icon:setAltas("common_altas_2", data.attr_icon_2);
end

function Lua_GodStatuePorpItem:dispose()
    self:superCall("dispose");
end
