--格子
Lua_GodTreeGridCell = class("Lua_GodTreeGridCell", Lua_ListCell);
function Lua_GodTreeGridCell:ctor(p)
    self:superCall("ctor", p,"LifeTreeGridCell_skin");
end

function Lua_GodTreeGridCell:buildShowItem()
    self:superCall("buildShowItem");
    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setScale(0.86,0.86);
    self.itemIcon:setCanClick(false);
    self.itemIcon:setSiblingIndex(0);
end

function Lua_GodTreeGridCell:setData(data)
	self.data = data;
    if data.isUnlock == true then--已解锁
        if data.isPutHero == true then--已放入英雄
            local hvo = DataCenter.heroData:getItemByUniqueId(data.hero_uid);
            self.itemIcon:setData(hvo);
            if hvo ~= nil then
            --最大等级
                 if DataCenter.lifeTreeData.break_state == 2 then--已突破
                    local bool;
                    if hvo.max_star <= 9 then
                        bool = hvo.level == hvo.max_lvl_limit;
                    else
                        bool = DataCenter.lifeTreeData.cur_level == DataCenter.lifeTreeData.level_limit
                    end
                    self.max_obj:SetActive(bool);
                else
                    self.max_obj:SetActive(hvo.level == hvo.max_lvl_limit);
                end
            end
            self.add:setEnable(false);
            self.cool:setEnable(false);
            self.cool_icon:setEnable(false);
        else
            local showTime = self.data.cold_time;
            local isUnActive = DataCenter.lifeTreeData.showHeroInfo:getSize() < 6 and DataCenter.lifeTreeData.break_state < 2;
            self.add:setEnable(showTime <= 0);
            self.add:setGray(isUnActive);
            self.max_obj:SetActive(false);
            self.itemIcon:setData(nil);
            self.itemIcon.iconBg:setAltas("common_altas_1", "xui_common_itembg_0");
            --冷缩
            self.cool:setEnable(showTime > 0);
            self.cool_icon:setEnable(showTime > 0);
        end
        self.lock:setEnable(false);
        self:showRedDot(false);
    else
        self.add:setEnable(false);
        self.lock:setEnable(true);
        self.cool:setEnable(false);
        self.max_obj:SetActive(false);
        self.cool_icon:setEnable(false);

        self.itemIcon:setData(nil);
        self.itemIcon.iconBg:setAltas("common_altas_1", "xui_common_itembg_0");
        self:showRedDot(data.unlockRedDot);
    end

    self:starTime()
end

function Lua_GodTreeGridCell:starTime()
    self.showTime = self.data.cold_time;
    if self.showTime > 0 then
        self.cool.text = Lua_TimeTransform.transSeconds6(self.showTime,true,true);
        Lua_CommonUtil.addTimer( "updateColdTime", 1, self, self.updateColdTime);
    else
        Lua_CommonUtil.removeTimer(self,self.updateColdTime);
    end
end

function Lua_GodTreeGridCell:updateColdTime()
    self.showTime = self.showTime -1;
    if self.showTime >= 0 then
        self.cool.text = Lua_TimeTransform.transSeconds6(self.showTime,true,true);
    else
        Lua_CommonUtil.removeTimer(self,self.updateColdTime);
        Lua_ProxyManager.getProxy("Lua_LifeTreeProxy"):slifeTreeInfo();
    end
end

--解锁红点
function Lua_GodTreeGridCell:showRedDot(val)
    if val == true then
        if self.redDotIcon == nil then
            self.redDotIcon = Lua_RedPointIcon.new(self.content);
            self.redDotIcon:setLocation(40, 40, 0);
            self.redDotIcon:createRedPointImg(nil);
        end
        self.redDotIcon:updateRedPointShow(true);
    else
        if self.redDotIcon ~= nil then
            self.redDotIcon:updateRedPointShow(false);
        end
    end
end

function Lua_GodTreeGridCell:onPressClick()
    if DataCenter.heroData.allHeroUidArr:getSize() < 5 then
        OperateAlert.showLangValue(126934);
        return;
    end
    
    if self.data.cold_time > 0 then
        self:showCoolTips();
        return
    end
    if self.data.isUnlock == true then
        if self.data.isPutHero == true then
            --卸下
            Lua_WindowUtil.openWin("Lua_GuardDemountTipsWindow", Lua_WinParam.ACTION_OPEN, {hero_uid = self.data.hero_uid, grid_id = self.data.id});
        else
            --选择英雄
            Lua_WindowUtil.openWin("Lua_GuardHeroSelectWindow", Lua_WinParam.ACTION_OPEN, self.data.id);
        end
    else
        if self.data.isAheadUnlock then--可解锁
            Lua_WindowUtil.openWin("Lua_GuardUnlockTipsWindow", Lua_WinParam.ACTION_OPEN, self.data);
        else
            OperateAlert.showLangValue(126926);
        end
    end
end

--冷缩tips
function Lua_GodTreeGridCell:showCoolTips()
    local num = DataCenter.lifeTreeUtil.grid_refresh_cost[1][2];
    local id = DataCenter.lifeTreeUtil.grid_refresh_cost[1][1];
    local tipData = {
        h = 443, titleAtlas = "life_tree_altas", titleSprite = "ui_tdq_title_03", font_size = 26,
        des = LanUtil.formateStr(126910, spliceIconStrById(id), LanUtil.formateStr(126915,tostring(num))),
        posY = 50, btnType = 1, owner = self, sureFun = self.onSubClick
    };
    Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end

--清除冷缩
function Lua_GodTreeGridCell:onSubClick()
    local id = DataCenter.lifeTreeUtil.grid_refresh_cost[1][1];
    local num = DataCenter.lifeTreeUtil.grid_refresh_cost[1][2];
    if DataCenter.moneyData:isMoneyEnough(id, num, true, true, false) then
        Lua_ProxyManager.getProxy("Lua_LifeTreeProxy"):sRefreshGrid(self.data.id);
    end
end

function Lua_GodTreeGridCell:dispose()
    self.data = nil;
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    if self.redDotIcon ~= nil then
        self.redDotIcon:dispose();
        self.redDotIcon = nil;
    end
    Lua_CommonUtil.removeTimer(self,self.updateColdTime);
    self:superCall("dispose");
end