-- 入驻守护英雄选择
Lua_GuardHeroSelectWindow = class("Lua_GuardHeroSelectWindow", Lua_Window);
function Lua_GuardHeroSelectWindow:ctor()
	self:superCall("ctor");
    self.showBlackMask = true;
    self.isClickClose = true;
	self.windowName = "Lua_GuardHeroSelectWindow";
	self.skinName = "GuardHeroSelectWindow_skin";
end

function Lua_GuardHeroSelectWindow:buildShowItem()
	self:superCall("buildShowItem");

    self.campSiftPanel = Lua_CampSiftPanel.new(self.content);
    self.campSiftPanel:setLocation(-32, -153, 0);
    self.campSiftPanel:setSiftItem(72,"726763");
    self.campSiftPanel:setArrayData(DataCenter.heroUtil.siftAllInfo);
    self.campSiftPanel:setCallBack(self, self.onCampSelected);
    
	self.dragList = Lua_DragList.new(self.content,612, 302, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_GuardHeroSelectCell, 112, 112, 5);
    self.dragList:setCellSpacing(13, 13);
    self.dragList:setLocation(0, 57);
    self.dragList.canLongPress = true;

    self.sub_btn:addClickFuntion(self, self.onSubBtnClick);
    self.cancel_btn:addClickFuntion(self, self.onCancelBtnClick);

    self:addLuaEvent("ON_SELECT_HERO_ITEM", self, self.onSelectItemInfo); -- 选择单个英雄返回
end

-- 英雄展示数据
function Lua_GuardHeroSelectWindow:showWin(param)
    self.grid_id = param;
    self.campSiftPanel:setSelected(Lua_HeroUtil.All_TYPE, true);
end

function Lua_GuardHeroSelectWindow:onCampSelected(selectType) -- 更新筛选状态
    if self.selectSiftType == selectType then
        return;
    end
    self.selectSiftType = selectType;
    
    self:updateDragInfo(selectType)
end

function Lua_GuardHeroSelectWindow:updateDragInfo(selectType)
    local arr = DataCenter.lifeTreeData:selectShowHeroInfo(selectType, self.select_uid);
    self.dragList:setArrayData(arr);
    self.dragList:moveToIndex(1,true);
    self.showObj:SetActive(arr:getSize()==0);
end

function Lua_GuardHeroSelectWindow:onSelectItemInfo(data)
    local bool;
    if self.select_uid == data.unique_id then
        bool = false;
        self.select_uid = nil;
    else
        bool = true;
        self.select_uid = data.unique_id;
    end
    self:updateSelect(data.unique_id, bool);
end

function Lua_GuardHeroSelectWindow:updateSelect(unique_id, bool)
    if unique_id == nil then
        return;
    end
    if self.dragList ~= nil then
        local arr = self.dragList.showDragDataList;
        local len = arr:getSize();
        for i = 1, len do
            if bool == true then
                arr[i].data.isSelect = (arr[i].data.data.unique_id == unique_id);
            else
                arr[i].data.isSelect = false;
            end
            if arr[i].cell ~= nil then
                arr[i].cell:updateSelect();
            end
        end
    end
end

function Lua_GuardHeroSelectWindow:onSubBtnClick() -- 确定
    if self.select_uid ~= nil then
        Lua_ProxyManager.getProxy("Lua_LifeTreeProxy"):sPutHero(self.select_uid, self.grid_id);
    end
    self:hide();
end

function Lua_GuardHeroSelectWindow:onCancelBtnClick()
    self:hide();
end

function Lua_GuardHeroSelectWindow:dispose()
    if self.itemList ~= nil then
        self.itemList:dispose();
        self.itemList = nil;
    end
    if self.campSiftPanel ~= nil then
        self.campSiftPanel:dispose();
        self.campSiftPanel = nil;
    end
    self:superCall("dispose");
end
































Lua_GuardHeroSelectCell = class("Lua_GuardHeroSelectCell", Lua_ListCell);
function Lua_GuardHeroSelectCell:ctor(p)
    self:superCall("ctor", p);
end

function Lua_GuardHeroSelectCell:buildShowItem()
	self:superCall("buildShowItem");

    self.itemIcon = Lua_ItemIcon.new(self.content);

    self.itemIcon:setLocation(0, 0, 0);
    self.itemIcon:setCanClick(false);

    self.select_sub = UICreate.createUIAtlasImage(self.content, "common_altas_3", "xui_common_label_14", 0, 0, 0, 0);
    self.select_sub:setScale(0.9,0.9,0.9);
    self.select_sub:setEnable(false);
end

function Lua_GuardHeroSelectCell:setData(data)
    self.data = data;
    self.itemIcon:setData(data.data);
    self.itemIcon:show_level(data.data.level);
    self.itemIcon:setScale(0.9,0.9,0.9);
	self:updateSelect();
end

function Lua_GuardHeroSelectCell:updateSelect()
    self.select_sub:setEnable(self.data.isSelect);
end

function Lua_GuardHeroSelectCell:onPressClick(go)
    Lua_MsgUtil.callFunc("ON_SELECT_HERO_ITEM",self.data.data);
end

function Lua_GuardHeroSelectCell:onLongPressClick()
    if not Lua_WindowUtil.isWindowShowing("Lua_HeroTipsWindow") then
        Lua_WindowUtil.openWin("Lua_HeroTipsWindow", Lua_WinParam.ACTION_OPEN, {heroVo = self.data.data});
    end
end

function Lua_GuardHeroSelectCell:dispose()
    self.data = nil;
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    self.select_sub = nil;
    self:superCall("dispose");
end